import java.util.Random;

class Gabel {
	
    private boolean benutzt;
    
    public Gabel() {
    	benutzt=false;
	}
    
    public synchronized boolean istBenutzt(){
    	return benutzt;
	}
    
    public synchronized void aufnehmen(){
		if (benutzt)
		    throw new IllegalArgumentException();
		benutzt=true;
		System.out.println("Gabel aufgenommen");
	}
    public synchronized void ablegen(){
    	benutzt=false;
    	System.out.println("Gabel abgelegt");
    }
}

class Philosoph extends Thread {
    private Gabel linke;
    private Gabel rechte;
    private String name;
    
    Random zufall;

    public Philosoph(String name, Gabel linke, Gabel rechte) {
    	this.name=name;
    	this.linke = linke; 
    	this.rechte=rechte;
    	zufall = new Random();
    }
    
    public void essen() {
    
    
	  synchronized(linke) {
		  linke.aufnehmen();
		  try {
			sleep(100);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	      synchronized(rechte) {
			  rechte.aufnehmen();  
	      	System.out.println(name + " isst.");
			rechte.ablegen();
			linke.ablegen();
	      }
	  } 
	  
    }

    public void run(){
		while (true) {
		    schlafen();
		    essen();
		}
    }

    public void schlafen() {
    	System.out.println(name + " schlaeft.");
		try {
			sleep(zufall.nextInt(1000));} 
		catch(InterruptedException e) 
		{
			
		}
    }      
}

public class PhilosophenProblem {
	
    public static void main(String[] args) {
	Gabel eins = new Gabel();
	Gabel zwei = new Gabel();
	Gabel drei = new Gabel();
	Gabel vier = new Gabel();
	Gabel fuenf = new Gabel();    
	Philosoph a = new Philosoph("A",eins,zwei);
	Philosoph b = new Philosoph("B",drei,zwei);
	Philosoph c = new Philosoph("C",drei,vier);
	Philosoph d = new Philosoph("D",fuenf,vier);
	Philosoph e = new Philosoph("E",fuenf,eins);

	a.start();
	b.start();
	c.start();
	d.start();
	e.start();
    }
}
