import java.util.Random;

class Gabel {
	
    private boolean benutzt;
    
    public Gabel() {
    	benutzt=false;
	}
    
    public synchronized boolean istBenutzt(){
    	return benutzt;
	}
    
    public synchronized void aufnehmen(){
		if (benutzt)
		    throw new IllegalArgumentException();
		benutzt=true;
		System.out.println("Gabel aufgenommen");
	}
    public synchronized void ablegen(){
    	benutzt=false;
    	System.out.println("Gabel abgelegt");
    }
}

class Philosoph extends Thread {
    private Gabel linke;
    private Gabel rechte;
    private String name;
    private Semaphore aufpasser;
    
    Random zufall;

    public Philosoph(String name, Gabel linke, Gabel rechte, Semaphore aufpasser) {
    	this.name=name;
    	this.linke = linke; 
    	this.rechte=rechte;
    	zufall = new Random();
    	this.aufpasser=aufpasser;
    }
    
    public void essen() throws InterruptedException{
    
    
    	aufpasser.down();	
    	synchronized(linke) {
		  linke.aufnehmen();
		  sleep(50);

	      synchronized(rechte) {
			  rechte.aufnehmen();
			  aufpasser.up();
	      	System.out.println(name + " isst.");
			rechte.ablegen();
			linke.ablegen();
	      }
	  } 
	  
    }

    public void run(){
		while (true) {
		    schlafen();
		    try {
				essen();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
    }

    public void schlafen() {
    	System.out.println(name + " schlaeft.");
		try {
			sleep(zufall.nextInt(1000));} 
		catch(InterruptedException e) 
		{
			
		}
    }      
}

public class PhilosophenProblemSynched {
	
    public static void main(String[] args) {
	Gabel eins = new Gabel();
	Gabel zwei = new Gabel();
	Gabel drei = new Gabel();
	Gabel vier = new Gabel();
	Gabel fuenf = new Gabel();    
	
	Semaphore aufpasser = new Semaphore(1);
	
	Philosoph a = new Philosoph("A",eins,zwei,aufpasser);
	Philosoph b = new Philosoph("B",zwei,drei,aufpasser);
	Philosoph c = new Philosoph("C",drei,vier,aufpasser);
	Philosoph d = new Philosoph("D",vier,fuenf,aufpasser);
	Philosoph e = new Philosoph("E",fuenf,eins,aufpasser);

	a.start();
	b.start();
	c.start();
	d.start();
	e.start();
    }
}
